using System;

namespace petlja2020_1_3
{
    class Program
    {
        static void Main(string[] args)
        {
            byte T = Convert.ToByte(Console.ReadLine());
            byte[] IO = new byte[T];
            for (int i = 0; i < T; i++)
            {
                IO[i] = 1;
            }



            for(int i = 0; i < T; i++)
            {
                int N;
                int M;
                {
                    string[] inp = Console.ReadLine().Split(' ');
                    N = Convert.ToInt32(inp[0]);
                    M = Convert.ToInt32(inp[1]);
                }
                
                ulong[] A = new ulong[N];
                {
                    string[] inp = Console.ReadLine().Split(' ');
                    for(int j = 0; j < N; j++)
                    {
                        A[j] = Convert.ToUInt64(inp[j]);
                    }
                }

                ulong[] B = new ulong[M];
                {
                    string[] inp = Console.ReadLine().Split(' ');
                    for (int j = 0; j < M; j++)
                    {
                        B[j] = Convert.ToUInt64(inp[j]);
                    }
                }

                Array.Sort(A);
                Array.Sort(B);
                ulong Amin = ulong.MaxValue;
                for (int j = 0; j < N - 1; j++)
                {
                    if (A[j + 1] - A[j] < Amin)
                    {
                        Amin = A[j + 1] - A[j];
                    }
                }
                for (int j = 0; j < N - 1; j++)
                {
                    if (!((A[j + 1] - A[j]) % Amin == 0))
                    {
                        IO[i] = 0;
                    }
                }
                for (int j = 0; j < M - 1; j++)
                {
                    if ((A[0] - B[j]) % Amin == 0)
                    {
                        IO[i] = 0;
                    }
                }

            }



            for(int i = 0; i < T; i++)
            {
                Console.WriteLine(IO[i]);
            }
        }
    }
}